/*
 * g_getopt.c -- unix-style command-line parameters
 *
 * part of TAAS
 *
 * 18jul94 glauber: Reformatted the code.
 * 18jul94 glauber: Hacked so that it accepts either '-' or '/'
 *                      as option separator.
 * 18jul94 glauber: inserted "#include"s 
 *                      and eliminated redundant prototypes,
 *                      to silence compiler warnings.
 * 18jul94 glauber: substituted "write" by "fprintf" 
 *                      and ANSIfied the function header.
 */

/*
 * Newsgroups: mod.std.unix
 * Subject: public domain AT&T getopt source
 * Date: 3 Nov 85 19:34:15 GMT
 * 
 * Here's something you've all been waiting for:  the AT&T public domain
 * source for getopt(3).  It is the code which was given out at the 1985
 * UNIFORUM conference in Dallas.  I obtained it by electronic mail
 * directly from AT&T.  The people there assure me that it is indeed
 * in the public domain.
 */

#include <stdio.h>
#include <string.h>


/*
 * 18jul94 glauber: was
 *
 * #define ERR(s, c)	if(opterr){\
 * 	extern int write();\
 * 	char errbuf[2];\
 * 	errbuf[0] = c; errbuf[1] = '\n';\
 * 	(void) write(2, argv[0], (unsigned)strlen(argv[0]));\
 * 	(void) write(2, s, (unsigned)strlen(s));\
 * 	(void) write(2, errbuf, 2);}
 */
 
#define ERR(s, c)	if(opterr){\
        fprintf( stderr, "%s", argv[0] );\
        fprintf( stderr, "%s", s );\
        fprintf( stderr, "%c\n", c );}



int   opterr = 1;
int   optind = 1;
int   optopt;
char *optarg;

int getopt( int argc, char ** argv, const char * opts )
{
    static int sp = 1;
    register int c;
    register char *cp;

    if ( sp == 1 )
        if ( optind >= argc ||
             /* 18jul94 glauber: added the check for '/' */
             (argv[optind][0] != '-' && argv[optind][0] != '/') || 
             argv[optind][1] == '\0' )
            return ( EOF );
        else if ( strcmp( argv[optind], "--" ) == NULL )
        {
            optind++;
            return ( EOF );
        }
    optopt = c = argv[optind][sp];
    if ( c == ':' || ( cp = strchr( opts, c ) ) == NULL )
    {
        ERR( ": illegal option -- ", c );
        if ( argv[optind][++sp] == '\0' )
        {
            optind++;
            sp = 1;
        }
        return ( '?' );
    }
    if ( *++cp == ':' )
    {
        if ( argv[optind][sp + 1] != '\0' )
            optarg = &argv[optind++][sp + 1];
        else if ( ++optind >= argc )
        {
            ERR( ": option requires an argument -- ", c );
            sp = 1;
            return ( '?' );
        } else
            optarg = argv[optind++];
        sp = 1;
    } else
    {
        if ( argv[optind][++sp] == '\0' )
        {
            sp = 1;
            optind++;
        }
        optarg = NULL;
    }
    return ( c );
}
